/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/

#include "system.h"
#include "usb.h"
#include "leds.h"
#include "buttons.h"
#include "adc.h"

unsigned char   system_flg=0;
unsigned char   g_mode=0;
unsigned char   s_mode=0;
unsigned char   sw_flg=0;
unsigned char   mode_data[35];
unsigned char   g00_data[35];
unsigned char   g01_data[35];
unsigned char   g02_data[35];
unsigned char   g03_data[35];
unsigned char   g04_data[35];
unsigned char   g05_data[35];
unsigned char   g06_data[35];
unsigned char   g07_data[35];
unsigned char   g08_data[35];
unsigned char   g09_data[35];
unsigned char   g10_data[35];
unsigned char   g11_data[35];
unsigned char   g12_data[35];
unsigned char   g13_data[35];
unsigned char   g14_data[35];
unsigned char   g15_data[35];
unsigned char   g16_data[35];
unsigned char   g17_data[35];
unsigned char   g18_data[35];
unsigned char   g19_data[35];

unsigned char   set_data1[20];
unsigned char   set_data2[20];

unsigned char   code_data[33];

unsigned char   data_cont[20];

unsigned char joy_data_new[10][10];

/** CONFIGURATION Bits **********************************************/
// CONFIG4
#pragma config DSWDTPS = DSWDTPS3       // DSWDT Postscale Select (1:128 (132 ms))
#pragma config DSWDTOSC = LPRC          // Deep Sleep Watchdog Timer Oscillator Select (DSWDT uses Low Power RC Oscillator (LPRC))
#pragma config RTCOSC = SOSC            // RTCC Reference Oscillator Select (RTCC uses Secondary Oscillator (SOSC))
#pragma config DSBOREN = OFF            // Deep Sleep BOR Enable bit (BOR disabled in Deep Sleep)
#pragma config DSWDTEN = OFF            // Deep Sleep Watchdog Timer (DSWDT disabled)

// CONFIG3
#pragma config WPFP = WPFP0             // Write Protection Flash Page Segment Boundary (Page 0 (0x0))
#pragma config SOSCSEL = IO //SOSC           // Secondary Oscillator Pin Mode Select (SOSC pins in Default (high drive-strength) Oscillator Mode)
#pragma config WUTSEL = LEG             // Voltage Regulator Wake-up Time Select (Default regulator start-up time used)
#pragma config WPDIS = WPDIS            // Segment Write Protection Disable (Segmented code protection disabled)
#pragma config WPCFG = WPCFGDIS         // Write Protect Configuration Page Select (Last page and Flash Configuration words are unprotected)
#pragma config WPEND = WPENDMEM         // Segment Write Protection End Page Select (Write Protect from WPFP to the last page of memory)

// CONFIG2
#pragma config POSCMOD = NONE   //HS             // Primary Oscillator Select (HS Oscillator mode selected)
#pragma config I2C1SEL = PRI            // I2C1 Pin Select bit (Use default SCL1/SDA1 pins for I2C1 )
#pragma config IOL1WAY = OFF            // IOLOCK One-Way Set Enable (The IOLOCK bit can be set and cleared using the unlock sequence)
#pragma config OSCIOFNC = ON            // OSCO Pin Configuration (OSCO pin functions as port I/O (RA3))
#pragma config FCKSM = CSDCMD           // Clock Switching and Fail-Safe Clock Monitor (Sw Disabled, Mon Disabled)
#pragma config FNOSC = FRCPLL   //PRIPLL           // Initial Oscillator Select (Primary Oscillator with PLL module (XTPLL, HSPLL, ECPLL))
#pragma config PLL96MHZ = ON            // 96MHz PLL Startup Select (96 MHz PLL Startup is enabled automatically on start-up)
#pragma config PLLDIV = DIV2            // USB 96 MHz PLL Prescaler Select (Oscillator input divided by 2 (8 MHz input))
#pragma config IESO = OFF               // Internal External Switchover (IESO mode (Two-Speed Start-up) disabled)

// CONFIG1
#pragma config WDTPS = PS1              // Watchdog Timer Postscaler (1:1)
#pragma config FWPSA = PR32             // WDT Prescaler (Prescaler ratio of 1:32)
#pragma config WINDIS = OFF             // Windowed WDT (Standard Watchdog Timer enabled,(Windowed-mode is disabled))
#pragma config FWDTEN = OFF             // Watchdog Timer (Watchdog Timer is disabled)
#pragma config ICS = PGx1               // Emulator Pin Placement Select bits (Emulator functions are shared with PGEC1/PGED1)
#pragma config GWRP = OFF               // General Segment Write Protect (Writes to program memory are allowed)
#pragma config GCP = OFF                // General Segment Code Protect (Code protection is disabled)
#pragma config JTAGEN = OFF             // JTAG Port Enable (JTAG port is disabled)

/*-------------------------WAIT----------------------------*/
void    wait_time(unsigned int time)
{
    while(time!=0){
        time--;
    }
}
/*------------------------EEPROM---------------------------*/
void    out_14bit(unsigned int data)
{
    unsigned char i;
    
    data=data << 2;
    for(i=0;i<14;i++){
        if((data&0x8000)==0x8000){
            EEPROM_DOUT=1;
        }
        else{
            EEPROM_DOUT=0;
        }
        wait_time(WAIT_E);
        EEPROM_CLK=1;
        wait_time(WAIT_E);
        EEPROM_CLK=0;
        data =data << 1;
        wait_time(WAIT_E);
    }
}
unsigned char in_8bit(void)
{
    unsigned char i,data;
    data=0;
    for(i=0;i<8;i++){
        data=data<<1;        
        EEPROM_CLK=1;
        wait_time(WAIT_E);
        if(EEPROM_DIN==1){
            data=data|0x001;
        }
        EEPROM_CLK=0;
        wait_time(WAIT_E);
    }
    
    return data;
}
unsigned char eepromread(unsigned int addr)
{
    unsigned int adata;
    unsigned char rdata;
    
    EEPROM_DOUT=0;
    adata=addr;
    adata=adata | 0x3000;
    EEPROM_CS=1;
    out_14bit(adata);
    EEPROM_DOUT=0;
    wait_time(WAIT_E);
    rdata=in_8bit();
    EEPROM_CS=0;
    
    return rdata;
}
void eepromread_cont(unsigned int addr,unsigned char *cdata,unsigned char no)
{
    unsigned int adata;
    //unsigned char data;
    unsigned char i;
    
    EEPROM_DOUT=0;
    adata=addr;
    adata=adata | 0x3000;
    EEPROM_CS=1;
    out_14bit(adata);
    EEPROM_DOUT=0;
    wait_time(WAIT_E);
    for(i=0;i<no;i++){
        cdata[i]=in_8bit();
    }
    EEPROM_CS=0;
}
unsigned char   eeprom_init_check_new(void)
{
    eepromread_cont(10,data_cont,16);
    //JOYSTIC TWIN 100  
    if(data_cont[0]!=74){return 0;}
    if(data_cont[1]!=79){return 0;}
    if(data_cont[2]!=89){return 0;}
    if(data_cont[3]!=83){return 0;}
    if(data_cont[4]!=84){return 0;}
    if(data_cont[5]!=73){return 0;}
    if(data_cont[6]!=67){return 0;}
    if(data_cont[7]!=32){return 0;}
    if(data_cont[8]!=84){return 0;}
    if(data_cont[9]!=87){return 0;}
    if(data_cont[10]!=73){return 0;}
    if(data_cont[11]!=78){return 0;}
    if(data_cont[12]!=32){return 0;}
    if(data_cont[13]!=49){return 0;}
    if(data_cont[14]!=48){return 0;}
    if(data_cont[15]!=48){return 0;}
    return 1;
}    
void    data_clear(void)
{
    unsigned char i,j;
    for(i=0;i<35;i++){
        mode_data[i]=255;
        g00_data[i]=255;
        g01_data[i]=255;
        g02_data[i]=255;
        g03_data[i]=255;
        g04_data[i]=255;
        g05_data[i]=255;
        g06_data[i]=255;
        g07_data[i]=255;
        g08_data[i]=255;
        g09_data[i]=255;
        g10_data[i]=255;
        g11_data[i]=255;
        g12_data[i]=255;
        g13_data[i]=255;
        g14_data[i]=255;
        g15_data[i]=255;
        g16_data[i]=255;
        g17_data[i]=255;
        g18_data[i]=255;
        g19_data[i]=255;
    }
    for(i=0;i<20;i++){
        set_data1[i]=255;
        set_data2[i]=255;
    }
    for(i=0;i<10;i++){
        for(j=0;j<10;j++){
            joy_data_new[i][j]=255;
        }
    }
}
void    eeprom_read_set(void)
{
    unsigned int addr;
    unsigned char i,j;    
    
    //addr=100;
    //for(i=0;i<35;i++){
    //    mode_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(100,mode_data,35);
    
    //addr=140;
    //for(i=0;i<35;i++){
    //    g00_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(140,g00_data,35);
    
    //addr=180;
    //for(i=0;i<35;i++){
    //    g01_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(180,g01_data,35);
    
    //addr=220;
    //for(i=0;i<35;i++){
    //    g02_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(220,g02_data,35);
    
    //addr=260;
    //for(i=0;i<35;i++){
    //    g03_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(260,g03_data,35);
    
    //addr=300;
    //for(i=0;i<35;i++){
    //    g04_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(300,g04_data,35);
    
    //addr=340;
    //for(i=0;i<35;i++){
    //    g05_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(340,g05_data,35);
    
    //addr=380;
    //for(i=0;i<35;i++){
    //    g06_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(380,g06_data,35);
    
    //addr=420;
    //for(i=0;i<35;i++){
    //    g07_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(420,g07_data,35);
    
    //addr=460;
    //for(i=0;i<35;i++){
    //    g08_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(460,g08_data,35);
    
    //addr=500;
    //for(i=0;i<35;i++){
    //    g09_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(500,g09_data,35);
    
    //addr=540;
    //for(i=0;i<35;i++){
    //    g10_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(540,g10_data,35);
    
    //addr=580;
    //for(i=0;i<35;i++){
    //    g11_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(580,g11_data,35);
    
    //addr=620;
    //for(i=0;i<35;i++){
    //    g12_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(620,g12_data,35);
    //addr=660;
    //for(i=0;i<35;i++){
    //    g13_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(660,g13_data,35);
    //addr=700;
    //for(i=0;i<35;i++){
    //    g14_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(700,g14_data,35);
    //addr=740;
    //for(i=0;i<35;i++){
    //    g15_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(740,g15_data,35);
    //addr=780;
    //for(i=0;i<35;i++){
    //    g16_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(780,g16_data,35);
    //addr=820;
    //for(i=0;i<35;i++){
    //    g17_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(820,g17_data,35);
    //addr=860;
    //for(i=0;i<35;i++){
    //    g18_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(860,g18_data,35);
    //addr=900;
    //for(i=0;i<35;i++){
    //    g19_data[i]=eepromread(addr);
    //    addr++;
    //}
    eepromread_cont(900,g19_data,35);
    
    addr=1000;
    for(i=0;i<20;i++){
        set_data1[i]=eepromread(addr);
        addr++;
        set_data2[i]=eepromread(addr);
        addr++;
    }
    
    addr=1500;
    for(i=0;i<10;i++){
        for(j=0;j<10;j++){
            joy_data_new[i][j ]=eepromread(addr);
            addr++;
        }
    }
}
/*--------------------GAME No---------------------------------*/
unsigned char   game_no_in(void)
{
    unsigned char   data;
    
    data=0;
    if(R_DIP0==0){
        data=data+0x01;
    }
    if(R_DIP1==0){
        data=data+0x02;
    }
    if(R_DIP2==0){
        data=data+0x04;
    }
    if(R_DIP3==0){
        data=data+0x08;
    }
    if(R_DIP4==0){
        data=data+0x10;
    }
    return data;
}
/*--------------------DATA SET MAIN---------------------------*/
void    data_set_main(void)
{
    unsigned char   i;
    
    g_mode=game_no_in();
    
    if(MODE_SW==0){
        for(i=0;i<35;i++){
            code_data[i]=mode_data[i];
        }
        s_mode=1;
    }
    else{
        s_mode=0;
        switch(g_mode){
            case 0:
                for(i=0;i<35;i++){
                    code_data[i]=g00_data[i];
                }                
                break;
            case 1:
                for(i=0;i<35;i++){
                    code_data[i]=g01_data[i];
                }                     
                break;
            case 2:
                for(i=0;i<35;i++){
                    code_data[i]=g02_data[i];
                }                     
                break;
            case 3:
                for(i=0;i<35;i++){
                    code_data[i]=g03_data[i];
                }                         
                break;
            case 4:
                for(i=0;i<35;i++){
                    code_data[i]=g04_data[i];
                }                             
                break;
            case 5:
                for(i=0;i<35;i++){
                    code_data[i]=g05_data[i];
                }                                 
                break;
            case 6:
                for(i=0;i<35;i++){
                    code_data[i]=g06_data[i];
                }                                     
                break;
            case 7:
                for(i=0;i<35;i++){
                    code_data[i]=g07_data[i];
                } 
                break;
            case 8:
                for(i=0;i<35;i++){
                    code_data[i]=g08_data[i];
                } 
                break;
            case 9:
                for(i=0;i<35;i++){
                    code_data[i]=g09_data[i];
                } 
                break;
            case 0x10:
                for(i=0;i<35;i++){
                    code_data[i]=g10_data[i];
                } 
                break;
            case 0x11:
                for(i=0;i<35;i++){
                    code_data[i]=g11_data[i];
                }                     
                break;
            case 0x12:
                for(i=0;i<35;i++){
                    code_data[i]=g12_data[i];
                }                         
                break;
            case 0x13:
                for(i=0;i<35;i++){
                    code_data[i]=g13_data[i];
                }                             
                break;
            case 0x14:
                for(i=0;i<35;i++){
                    code_data[i]=g14_data[i];
                }                                 
                break;
            case 0x15:
                for(i=0;i<35;i++){
                    code_data[i]=g15_data[i];
                }                                     
                break;
            case 0x16:
                for(i=0;i<35;i++){
                    code_data[i]=g16_data[i];
                }                                         
                break;
            case 0x17:
                for(i=0;i<35;i++){
                    code_data[i]=g17_data[i];
                }                                             
                break;
            case 0x18:
                for(i=0;i<35;i++){
                    code_data[i]=g18_data[i];
                }                                                 
                break;
            case 0x19:
                for(i=0;i<35;i++){
                    code_data[i]=g19_data[i];
                }                                                     
                break;
        }
    }
}
/*********************************************************************
* Function: void SYSTEM_Initialize( SYSTEM_STATE state )
*
* Overview: Initializes the system.
*
* PreCondition: None
*
* Input:  SYSTEM_STATE - the state to initialize the system into
*
* Output: None
*
********************************************************************/
void SYSTEM_Initialize( SYSTEM_STATE state )
{
    unsigned char   i;
    
    //Init
    _SWDTEN = 0;        // 
    // Fosc=32MHz FCY=16MIPS
    _RCDIV = 0b000;     // FRC 8MHz
    _CPDIV = 0b00;      // 96MHz PLL Fosc=32MHz
    
    AD1PCFG = 0b1111111111110000;   //AN4-AN12 DEGITAL I/O
    
    TRISBbits.TRISB15=0;    // RB15=OUT
    TRISBbits.TRISB9=0;     // RB9=OUT
    TRISBbits.TRISB8=0;     // RB8=OUT
    LATBbits.LATB15=0;      // RB15=0
    LATBbits.LATB9=0;       // RB9=0
    LATBbits.LATB8=0;       // RB8=0

    TRISAbits.TRISA0=1;     // RA0=IN
    TRISAbits.TRISA1=1;     // RA1=IN
    TRISAbits.TRISA2=1;     // RA2=IN
    TRISAbits.TRISA3=1;     // RA3=IN
    TRISAbits.TRISA4=1;     // RA4=IN
    TRISAbits.TRISA7=1;     // RA7=IN    
    TRISAbits.TRISA8=1;     // RA8=IN
    TRISAbits.TRISA9=1;     // RA9=IN
    TRISAbits.TRISA10=1;    // RA10=IN    
    TRISBbits.TRISB0=1;     // RB0=IN
    TRISBbits.TRISB1=1;     // RB1=IN    
    TRISBbits.TRISB2=1;     // RB2=IN
    TRISBbits.TRISB3=1;     // RB3=IN
    TRISBbits.TRISB4=1;     // RB4=IN
    TRISBbits.TRISB5=1;     // RB5=IN
    TRISBbits.TRISB7=1;     // RB7=IN
    TRISBbits.TRISB13=1;    // RB13=IN
    TRISBbits.TRISB14=1;    // RB14=IN    
    TRISCbits.TRISC0=1;     // RC0=IN    
    TRISCbits.TRISC1=1;     // RC1=IN
    TRISCbits.TRISC2=1;     // RC2=IN
    TRISCbits.TRISC3=1;     // RC3=IN
    TRISCbits.TRISC4=1;     // RC4=IN
    TRISCbits.TRISC5=1;     // RC5=IN
    TRISCbits.TRISC6=1;     // RC6=IN
    TRISCbits.TRISC7=1;     // RC7=IN
    TRISCbits.TRISC8=1;     // RC8=IN
    TRISCbits.TRISC9=1;     // RC9=IN    

    ADC_SetConfiguration(ADC_CONFIGURATION_DEFAULT);
    
    ADC_ChannelEnable(0);
    ADC_ChannelEnable(1);
    ADC_ChannelEnable(2);
    ADC_ChannelEnable(3);
    
    data_clear();
    //system_flg=eeprom_init_check();
    system_flg=eeprom_init_check_new();
    if(system_flg==1){
        eeprom_read_set();
    }
    data_set_main();

    
    switch(state)
    {
        case SYSTEM_STATE_USB_START:
            //On the PIC24FJ64GB004 Family of USB microcontrollers, the PLL will not power up and be enabled
            //by default, even if a PLL enabled oscillator configuration is selected (such as HS+PLL).
            //This allows the device to power up at a lower initial operating frequency, which can be
            //advantageous when powered from a source which is not gauranteed to be adequate for 32MHz
            //operation.  On these devices, user firmware needs to manually set the CLKDIV<PLLEN> bit to
            //power up the PLL.
            {
                unsigned int pll_startup_counter = 600;
                CLKDIVbits.PLLEN = 1;
                while(pll_startup_counter--);
            }
        
            //LED_Enable(LED_USB_DEVICE_STATE);
            //LED_Enable(LED_USB_DEVICE_HID_KEYBOARD_CAPS_LOCK);
            
            //BUTTON_Enable(BUTTON_USB_DEVICE_HID_KEYBOARD_KEY);
            break;
            
        case SYSTEM_STATE_USB_SUSPEND:
            //If developing a bus powered USB device that needs to be USB compliant,
            //insert code here to reduce the I/O pin and microcontroller power consumption,
            //so that the total current is <2.5mA from the USB host's VBUS supply.
            //If developing a self powered application (or a bus powered device where
            //official USB compliance isn't critical), nothing strictly needs
            //to be done during USB suspend.

            USBSleepOnSuspend();
            break;

        case SYSTEM_STATE_USB_RESUME:
            //Here would be a good place to restore I/O pins and application states
            //back to their original values that may have been saved/changed at the 
            //start of the suspend event (ex: when the SYSTEM_Initialize(SYSTEM_STATE_USB_SUSPEND)
            //callback was called.
            
            //If you didn't change any I/O pin states prior to entry into suspend,
            //then nothing explicitly needs to be done here.  However, by the time
            //the firmware returns from this function, the full application should
            //be restored into effectively exactly the same state as the application
            //was in, prior to entering USB suspend.
            
            //Additionally, before returning from this function, make sure the microcontroller's
            //currently active clock settings are compatible with USB operation, including
            //taking into consideration all possible microcontroller features/effects
            //that can affect the oscillator settings (such as internal/external 
            //switchover (two speed start up), fail-safe clock monitor, PLL lock time,
            //external crystal/resonator startup time (if using a crystal/resonator),
            //etc.

            //Additionally, the official USB specifications dictate that USB devices
            //must become fully operational and ready for new host requests/normal 
            //USB communication after a 10ms "resume recovery interval" has elapsed.
            //In order to meet this timing requirement and avoid possible issues,
            //make sure that all necessary oscillator startup is complete and this
            //function has returned within less than this 10ms interval.

            break;

        default:
            break;
    }
}

#if defined(USB_INTERRUPT)
void __attribute__((interrupt,auto_psv)) _USB1Interrupt()
{
    USBDeviceTasks();
}
#endif

